/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1 "cmdline.opt"
/* This file is part of cfpeek  -*- c -*-
   Copyright (C) 2011, 2012 Sergey Poznyakoff

   Cfpeek is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Cfpeek is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with cfpeek.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifdef HAVE_GETOPT_H
# include <getopt.h>
#endif
#include <unistd.h>
#include "grecs/gitid.h"

static struct grecs_txtacc *pp_cmd_acc;
char *program_name;

#define PREPROC_NOT_SET 0
#define PREPROC_SET     1
#define PREPROC_DEFAULT 2
static int preproc_settings = PREPROC_NOT_SET;

#define CFPEEK_NODE_FLAG_DEFAULT \
	(GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE|GRECS_NODE_FLAG_DESCEND)

static int flags_on, flags_off;

struct format_flag {
	char *name;
	char *arg;
	char *descr;
	int flag;
	void (*handler)(const char *);
};

static void
set_parent_option(const char *str)
{
	struct locate_instr *instr = new_locate_instr();
	instr->cmd = locate_parent;
	instr->v.s = grecs_strdup(str);
}

static void
set_child_option(const char *str)
{
	struct locate_instr *instr = new_locate_instr();
	instr->cmd = locate_child;
	instr->v.s = grecs_strdup(str);
}

static void
set_sibling_option(const char *str)
{
	struct locate_instr *instr = new_locate_instr();
	instr->cmd = locate_sibling;
	instr->v.s = grecs_strdup(str);
}

static void
set_up_option(const char *str)
{
	struct locate_instr *instr = new_locate_instr();
	instr->cmd = locate_up;
	instr->v.n = atoi(str);
}

static void
set_down_option(const char *str)
{
	struct locate_instr *instr = new_locate_instr();
	instr->cmd = locate_down;
	instr->v.n = atoi(str);
}

static void
set_delim_option(const char *str)
{
	flags_on |= *str & 0xff;
}

struct format_flag format_flag_table[] = {
	{ "parent", "NAME", "print the parent node with the given NAME",
	  0, set_parent_option },
	{ "child", "NAME", "print the child node with the given NAME",
	  0, set_child_option },
	{ "up", "NUMBER", "ascend NUMBER of nodes",
	  0, set_up_option },
	{ "down", "NUMBER", "descend NUMBER of nodes",
	  0, set_down_option },
	{ "sibling",
	  "NAME", "locate a sibling with the given NAME and print it",
	  0, set_sibling_option },
	{ "delim", "CHAR", "set path component delimiter",
	  0, set_delim_option },
	{ "locus", NULL, "print locations",
	  GRECS_NODE_FLAG_LOCUS },
	{ "path", NULL, "print paths",
	  GRECS_NODE_FLAG_PATH },
	{ "value", NULL, "print values",
	  GRECS_NODE_FLAG_VALUE },
	{ "quote", NULL, "always quote values",
	  GRECS_NODE_FLAG_QUOTE },
	{ "never-quote", NULL, "never quote values",
	  GRECS_NODE_FLAG_NOQUOTE },
	{ "quote-hex", NULL, "show unprintable characters as hex",
	  GRECS_NODE_FLAG_QUOTE_HEX },
	{ "descend", NULL, "descend into subnodes",
	  GRECS_NODE_FLAG_DESCEND },
	{ "default", NULL, "set default options",
	  CFPEEK_NODE_FLAG_DEFAULT },
	{ NULL }
};

static void
flags_help(FILE *stream)
{
	struct format_flag *fp;

	fprintf(stream, "[*] FLAGS is a comma-separated list of the following:\n");

	for (fp = format_flag_table; fp->name; fp++) {
		int n;
		fprintf(stream, "  ");
		if (fp->arg)
			n = fprintf(stream, "%s=%s", fp->name, fp->arg);
		else
			n = fprintf(stream, "[no]%s", fp->name);
		if (n < 24)
			n = 24 - n;
		else
			n = 2;
		fprintf(stream, "%*s%s\n", n, "", fp->descr);
	}
	fputc('\n', stream);
}

static const char *
cmpasgn(const char *a, const char *b)
{
	for (; *a && *b; a++, b++)  {
		if (*a != *b)
			return NULL;
	}
	if (*a == 0 && *b == '=')
		return b+1;

	return NULL;
}

static void
set_flag(const char *str)
{
	struct format_flag *fp;

	for (fp = format_flag_table; fp->name; fp++) {
		if (fp->arg) {
			const char *arg = cmpasgn(fp->name, str);
			if (arg) {
				fp->handler(arg);
				return;
			}
		} else if (strcmp(str, fp->name) == 0) {
			if (fp->handler)
				fp->handler(str);
			else
				flags_on |= fp->flag;
			return;
		} else if (strncmp(str, "no", 2) == 0 &&
			   strcmp(str + 2, fp->name) == 0) {
			if (fp->handler)
				fp->handler(str);
			else
				flags_off |= fp->flag;
			return;
		}
	}
	grecs_error(NULL, 0, "unknown option: %s", str);
}

#line 189 "cmdline.opt"

#line 189
void print_help(void);
#line 189
void print_usage(void);
#line 370 "cmdline.opt"

#line 370
#include <grecs.h>
#line 370
/* Option codes */
#line 370
enum {
#line 370
	_OPTION_INIT=255,
#line 370
	#line 370 "cmdline.opt"

#line 370
	OPTION_USAGE,

#line 370 "cmdline.opt"
	MAX_OPTION
#line 370
};
#line 370
#ifdef HAVE_GETOPT_LONG
#line 370
static struct option long_options[] = {
#line 370
	#line 198 "cmdline.opt"

#line 198
	{ "format", required_argument, 0, 'H' },
#line 214 "cmdline.opt"

#line 214
	{ "quiet", no_argument, 0, 'q' },
#line 222 "cmdline.opt"

#line 222
	{ "parser", required_argument, 0, 'p' },
#line 243 "cmdline.opt"

#line 243
	{ "literal", no_argument, 0, 'L' },
#line 249 "cmdline.opt"

#line 249
	{ "reduce", no_argument, 0, 'r' },
#line 255 "cmdline.opt"

#line 255
	{ "sort", no_argument, 0, 'S' },
#line 261 "cmdline.opt"

#line 261
	{ "matches", required_argument, 0, 'm' },
#line 267 "cmdline.opt"

#line 267
	{ "set", required_argument, 0, 's' },
#line 290 "cmdline.opt"

#line 290
	{ "lang", required_argument, 0, 'l' },
#line 296 "cmdline.opt"

#line 296
	{ "file", required_argument, 0, 'f' },
#line 302 "cmdline.opt"

#line 302
	{ "expression", required_argument, 0, 'e' },
#line 308 "cmdline.opt"

#line 308
	{ "init", required_argument, 0, 'i' },
#line 316 "cmdline.opt"

#line 316
	{ "include-directory", required_argument, 0, 'I' },
#line 324 "cmdline.opt"

#line 324
	{ "define", required_argument, 0, 'D' },
#line 342 "cmdline.opt"

#line 342
	{ "preprocessor", required_argument, 0, 'P' },
#line 349 "cmdline.opt"

#line 349
	{ "no-preprocessor", no_argument, 0, 'N' },
#line 358 "cmdline.opt"

#line 358
	{ "debug-parser", no_argument, 0, 'x' },
#line 364 "cmdline.opt"

#line 364
	{ "debug-lexer", no_argument, 0, 'X' },
#line 370 "cmdline.opt"

#line 370
	{ "help", no_argument, 0, 'h' },
#line 370 "cmdline.opt"

#line 370
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 370 "cmdline.opt"

#line 370
	{ "version", no_argument, 0, 'V' },

#line 370 "cmdline.opt"
	{0, 0, 0, 0}
#line 370
};
#line 370
#endif
#line 370
static struct opthelp {
#line 370
	const char *opt;
#line 370
	const char *arg;
#line 370
	int is_optional;
#line 370
	const char *descr;
#line 370
} opthelp[] = {
#line 370
	#line 196 "cmdline.opt"

#line 196
	{ NULL, NULL, 0, N_("Output control") },
#line 200 "cmdline.opt"

#line 200
	{
#line 200
#ifdef HAVE_GETOPT_LONG
#line 200
	  "-H, --format",
#line 200
#else
#line 200
	  "-H",
#line 200
#endif
#line 200
				   N_("FLAGS"), 0, N_("set output format flags [*]") },
#line 216 "cmdline.opt"

#line 216
	{
#line 216
#ifdef HAVE_GETOPT_LONG
#line 216
	  "-q, --quiet",
#line 216
#else
#line 216
	  "-q",
#line 216
#endif
#line 216
				   NULL, 0, N_("suppress error diagnostics") },
#line 220 "cmdline.opt"

#line 220
	{ NULL, NULL, 0, N_("Modifiers") },
#line 224 "cmdline.opt"

#line 224
	{
#line 224
#ifdef HAVE_GETOPT_LONG
#line 224
	  "-p, --parser",
#line 224
#else
#line 224
	  "-p",
#line 224
#endif
#line 224
				   N_("GRECS|META1|BIND|GIT|PATH"), 0, N_("set parser type") },
#line 245 "cmdline.opt"

#line 245
	{
#line 245
#ifdef HAVE_GETOPT_LONG
#line 245
	  "-L, --literal",
#line 245
#else
#line 245
	  "-L",
#line 245
#endif
#line 245
				   NULL, 0, N_("use literal matching") },
#line 251 "cmdline.opt"

#line 251
	{
#line 251
#ifdef HAVE_GETOPT_LONG
#line 251
	  "-r, --reduce",
#line 251
#else
#line 251
	  "-r",
#line 251
#endif
#line 251
				   NULL, 0, N_("reduce the tree") },
#line 257 "cmdline.opt"

#line 257
	{
#line 257
#ifdef HAVE_GETOPT_LONG
#line 257
	  "-S, --sort",
#line 257
#else
#line 257
	  "-S",
#line 257
#endif
#line 257
				   NULL, 0, N_("sort parse tree lexicografically") },
#line 263 "cmdline.opt"

#line 263
	{
#line 263
#ifdef HAVE_GETOPT_LONG
#line 263
	  "-m, --matches",
#line 263
#else
#line 263
	  "-m",
#line 263
#endif
#line 263
				   N_("NUMBER"), 0, N_("output at most NUMBER matches") },
#line 269 "cmdline.opt"

#line 269
	{
#line 269
#ifdef HAVE_GETOPT_LONG
#line 269
	  "-s, --set",
#line 269
#else
#line 269
	  "-s",
#line 269
#endif
#line 269
				   N_("PATH=VAL"), 0, N_("set a keyword") },
#line 288 "cmdline.opt"

#line 288
	{ NULL, NULL, 0, N_("Scripting") },
#line 292 "cmdline.opt"

#line 292
	{
#line 292
#ifdef HAVE_GETOPT_LONG
#line 292
	  "-l, --lang",
#line 292
#else
#line 292
	  "-l",
#line 292
#endif
#line 292
				   N_("NAME"), 0, N_("select scripting language to use") },
#line 298 "cmdline.opt"

#line 298
	{
#line 298
#ifdef HAVE_GETOPT_LONG
#line 298
	  "-f, --file",
#line 298
#else
#line 298
	  "-f",
#line 298
#endif
#line 298
				   N_("FILE"), 0, N_("load the script FILE") },
#line 304 "cmdline.opt"

#line 304
	{
#line 304
#ifdef HAVE_GETOPT_LONG
#line 304
	  "-e, --expression",
#line 304
#else
#line 304
	  "-e",
#line 304
#endif
#line 304
				   N_("EXPR"), 0, N_("apply this expression to each node found") },
#line 310 "cmdline.opt"

#line 310
	{
#line 310
#ifdef HAVE_GETOPT_LONG
#line 310
	  "-i, --init",
#line 310
#else
#line 310
	  "-i",
#line 310
#endif
#line 310
				   N_("EXPR"), 0, N_("initial setup expession") },
#line 314 "cmdline.opt"

#line 314
	{ NULL, NULL, 0, N_("Preprocessor control") },
#line 318 "cmdline.opt"

#line 318
	{
#line 318
#ifdef HAVE_GETOPT_LONG
#line 318
	  "-I, --include-directory",
#line 318
#else
#line 318
	  "-I",
#line 318
#endif
#line 318
				   N_("DIR"), 0, N_("add include directory") },
#line 326 "cmdline.opt"

#line 326
	{
#line 326
#ifdef HAVE_GETOPT_LONG
#line 326
	  "-D, --define",
#line 326
#else
#line 326
	  "-D",
#line 326
#endif
#line 326
				   N_("SYMBOL[=VALUE]"), 0, N_("define a preprocessor symbol") },
#line 344 "cmdline.opt"

#line 344
	{
#line 344
#ifdef HAVE_GETOPT_LONG
#line 344
	  "-P, --preprocessor",
#line 344
#else
#line 344
	  "-P",
#line 344
#endif
#line 344
				   N_("COMMAND"), 0, N_("use COMMAND instead of the default preprocessor") },
#line 351 "cmdline.opt"

#line 351
	{
#line 351
#ifdef HAVE_GETOPT_LONG
#line 351
	  "-N, --no-preprocessor",
#line 351
#else
#line 351
	  "-N",
#line 351
#endif
#line 351
				   NULL, 0, N_("disable preprocessing") },
#line 356 "cmdline.opt"

#line 356
	{ NULL, NULL, 0, N_("Debugging") },
#line 360 "cmdline.opt"

#line 360
	{
#line 360
#ifdef HAVE_GETOPT_LONG
#line 360
	  "-x, --debug-parser",
#line 360
#else
#line 360
	  "-x",
#line 360
#endif
#line 360
				   NULL, 0, N_("debug configuration file parser") },
#line 366 "cmdline.opt"

#line 366
	{
#line 366
#ifdef HAVE_GETOPT_LONG
#line 366
	  "-X, --debug-lexer",
#line 366
#else
#line 366
	  "-X",
#line 366
#endif
#line 366
				   NULL, 0, N_("debug configuration file lexer") },
#line 370 "cmdline.opt"

#line 370
	{ NULL, NULL, 0, N_("Other options") },
#line 370 "cmdline.opt"

#line 370
	{
#line 370
#ifdef HAVE_GETOPT_LONG
#line 370
	  "-h, --help",
#line 370
#else
#line 370
	  "-h",
#line 370
#endif
#line 370
				   NULL, 0, N_("Give this help list") },
#line 370 "cmdline.opt"

#line 370
	{
#line 370
#ifdef HAVE_GETOPT_LONG
#line 370
	  "--usage",
#line 370
#else
#line 370
	  "",
#line 370
#endif
#line 370
				   NULL, 0, N_("Give a short usage message") },
#line 370 "cmdline.opt"

#line 370
	{
#line 370
#ifdef HAVE_GETOPT_LONG
#line 370
	  "-V, --version",
#line 370
#else
#line 370
	  "-V",
#line 370
#endif
#line 370
				   NULL, 0, N_("Print program version") },

#line 370 "cmdline.opt"
};
#line 189 "cmdline.opt"

#line 189
const char *program_version = "cfpeek" " (" PACKAGE_NAME ") " PACKAGE_VERSION;
#line 189
static char doc[] = N_("Get variables from a configuration file");
#line 189
static char args_doc[] = N_("FILE [PATH...]");
#line 189
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 189
struct grecs_node *cmdline_tree;
#line 189

#line 189
#define DESCRCOLUMN 30
#line 189
#define RMARGIN 79
#line 189
#define GROUPCOLUMN 2
#line 189
#define USAGECOLUMN 13
#line 189

#line 189
static void
#line 189
indent (size_t start, size_t col)
#line 189
{
#line 189
  for (; start < col; start++)
#line 189
    putchar (' ');
#line 189
}
#line 189

#line 189
static void
#line 189
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 189
{
#line 189
  while (*descr)
#line 189
    {
#line 189
      size_t s = 0;
#line 189
      size_t i;
#line 189
      size_t width = rmargin - lmargin;
#line 189

#line 189
      for (i = 0; ; i++)
#line 189
	{
#line 189
	  if (descr[i] == 0 || descr[i] == ' ' || descr[i] == '\t')
#line 189
	    {
#line 189
	      if (i > width)
#line 189
		break;
#line 189
	      s = i;
#line 189
	      if (descr[i] == 0)
#line 189
		break;
#line 189
	    }
#line 189
	}
#line 189
      printf ("%*.*s\n", s, s, descr);
#line 189
      descr += s;
#line 189
      if (*descr)
#line 189
	{
#line 189
	  indent (0, lmargin);
#line 189
	  descr++;
#line 189
	}
#line 189
    }
#line 189
}
#line 189

#line 189
#define NOPTHELP (sizeof (opthelp) / sizeof (opthelp[0]))
#line 189

#line 189
static int
#line 189
optcmp (const void *a, const void *b)
#line 189
{
#line 189
  struct opthelp const *ap = (struct opthelp const *)a;
#line 189
  struct opthelp const *bp = (struct opthelp const *)b;
#line 189
  const char *opta, *optb;
#line 189
  size_t alen, blen;
#line 189

#line 189
  for (opta = ap->opt; *opta == '-'; opta++)
#line 189
    ;
#line 189
  alen = strcspn (opta, ",");
#line 189
  
#line 189
  for (optb = bp->opt; *optb == '-'; optb++)
#line 189
    ;
#line 189
  blen = strcspn (optb, ",");
#line 189

#line 189
  if (alen > blen)
#line 189
    blen = alen;
#line 189
  
#line 189
  return strncmp (opta, optb, blen);
#line 189
}
#line 189

#line 189
static void
#line 189
sort_options (int start, int count)
#line 189
{
#line 189
  qsort (opthelp + start, count, sizeof (opthelp[0]), optcmp);
#line 189
}
#line 189

#line 189
static int
#line 189
sort_group (int start)
#line 189
{
#line 189
  int i;
#line 189
  
#line 189
  for (i = start; i < NOPTHELP && opthelp[i].opt; i++)
#line 189
    ;
#line 189
  sort_options (start, i - start);
#line 189
  return i + 1;
#line 189
}
#line 189

#line 189
static void
#line 189
sort_opthelp (void)
#line 189
{
#line 189
  int start;
#line 189

#line 189
  for (start = 0; start < NOPTHELP; )
#line 189
    {
#line 189
      if (!opthelp[start].opt)
#line 189
	start = sort_group (start + 1);
#line 189
      else 
#line 189
	start = sort_group (start);
#line 189
    }
#line 189
}
#line 189

#line 189
void (*print_help_hook) (FILE *stream);
#line 189

#line 189
void
#line 189
print_help (void)
#line 189
{
#line 189
  unsigned i;
#line 189
  int argsused = 0;
#line 189

#line 189
  printf ("%s %s [%s]... %s\n", _("Usage:"), "cfpeek", _("OPTION"),
#line 189
	  args_doc[0] ? gettext (args_doc) : args_doc);
#line 189
  if (doc[0])
#line 189
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 189
  putchar ('\n');
#line 189

#line 189
  sort_opthelp ();
#line 189
  for (i = 0; i < NOPTHELP; i++)
#line 189
    {
#line 189
      unsigned n;
#line 189
      if (opthelp[i].opt)
#line 189
	{
#line 189
	  n = printf ("  %s", opthelp[i].opt);
#line 189
	  if (opthelp[i].arg)
#line 189
	    {
#line 189
	      char *cb, *ce;
#line 189
	      argsused = 1;
#line 189
	      if (strlen (opthelp[i].opt) == 2)
#line 189
		{
#line 189
		  if (!opthelp[i].is_optional)
#line 189
		    {
#line 189
		      putchar (' ');
#line 189
		      n++;
#line 189
		    }
#line 189
		}
#line 189
	      else
#line 189
		{
#line 189
		  putchar ('=');
#line 189
		  n++;
#line 189
		}
#line 189
	      if (opthelp[i].is_optional)
#line 189
		{
#line 189
		  cb = "[";
#line 189
		  ce = "]";
#line 189
		}
#line 189
	      else
#line 189
		cb = ce = "";
#line 189
	      n += printf ("%s%s%s", cb, gettext (opthelp[i].arg), ce);
#line 189
	    }
#line 189
	  if (n >= DESCRCOLUMN)
#line 189
	    {
#line 189
	      putchar ('\n');
#line 189
	      n = 0;
#line 189
	    }
#line 189
	  indent (n, DESCRCOLUMN);
#line 189
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 189
	}
#line 189
      else
#line 189
	{
#line 189
	  if (i)
#line 189
	    putchar ('\n');
#line 189
	  indent (0, GROUPCOLUMN);
#line 189
	  print_option_descr (gettext (opthelp[i].descr),
#line 189
			      GROUPCOLUMN, RMARGIN);
#line 189
	  putchar ('\n');
#line 189
	}
#line 189
    }
#line 189

#line 189
  putchar ('\n');
#line 189
  if (argsused)
#line 189
    {
#line 189
      print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 189
      putchar ('\n');
#line 189
    }
#line 189
 
#line 189
  if (print_help_hook)
#line 189
    print_help_hook (stdout);
#line 189
    
#line 189
 /* TRANSLATORS: The placeholder indicates the bug-reporting address
    for this package.  Please add _another line_ saying
    "Report translation bugs to <...>\n" with the address for translation
    bugs (typically your translation team's web or email address).  */
#line 189
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 189
  
#line 189
#ifdef PACKAGE_URL
#line 189
  printf (_("%s home page: <%s>\n"), PACKAGE_NAME, PACKAGE_URL);
#line 189
#endif
#line 189
}
#line 189

#line 189
static int
#line 189
cmpidx_short (const void *a, const void *b)
#line 189
{
#line 189
  unsigned const *ai = (unsigned const *)a;
#line 189
  unsigned const *bi = (unsigned const *)b;
#line 189

#line 189
  return opthelp[*ai].opt[1] - opthelp[*bi].opt[1];
#line 189
}
#line 189
  
#line 189
#ifdef HAVE_GETOPT_LONG
#line 189
static int
#line 189
cmpidx_long (const void *a, const void *b)
#line 189
{
#line 189
  unsigned const *ai = (unsigned const *)a;
#line 189
  unsigned const *bi = (unsigned const *)b;
#line 189
  struct opthelp const *ap = opthelp + *ai;
#line 189
  struct opthelp const *bp = opthelp + *bi;
#line 189
  char const *opta, *optb;
#line 189
  size_t lena, lenb;
#line 189

#line 189
  if (ap->opt[1] == '-')
#line 189
    opta = ap->opt;
#line 189
  else
#line 189
    opta = ap->opt + 4;
#line 189
  lena = strcspn (opta, ",");
#line 189
  
#line 189
  if (bp->opt[1] == '-')
#line 189
    optb = bp->opt;
#line 189
  else
#line 189
    optb = bp->opt + 4;
#line 189
  lenb = strcspn (optb, ",");
#line 189
  return strncmp (opta, optb, lena > lenb ? lenb : lena);
#line 189
}
#line 189
#endif
#line 189

#line 189
void
#line 189
print_usage (void)
#line 189
{
#line 189
  unsigned i;
#line 189
  unsigned n;
#line 189
  char buf[RMARGIN+1];
#line 189
  unsigned *idxbuf;
#line 189
  unsigned nidx;
#line 189
  
#line 189
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 189
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 189

#line 189
  idxbuf = calloc (NOPTHELP, sizeof (idxbuf[0]));
#line 189
  if (!idxbuf)
#line 189
    {
#line 189
      fprintf (stderr, "not enough memory");
#line 189
      abort ();
#line 189
    }
#line 189

#line 189
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "cfpeek");
#line 189

#line 189
  /* Print a list of short options without arguments. */
#line 189
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 189
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 189
	  && opthelp[i].arg == NULL)
#line 189
	idxbuf[nidx++] = i;
#line 189

#line 189
  if (nidx)
#line 189
    {
#line 189
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_short);
#line 189

#line 189
      ADDC ('[');
#line 189
      ADDC ('-');
#line 189
      for (i = 0; i < nidx; i++)
#line 189
	{
#line 189
	  ADDC (opthelp[idxbuf[i]].opt[1]);
#line 189
	}
#line 189
      ADDC (']');
#line 189
    }
#line 189

#line 189
  /* Print a list of short options with arguments. */
#line 189
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 189
    {
#line 189
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 189
	  && opthelp[i].arg)
#line 189
	idxbuf[nidx++] = i;
#line 189
    }
#line 189

#line 189
  if (nidx)
#line 189
    {
#line 189
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_short);
#line 189
    
#line 189
      for (i = 0; i < nidx; i++)
#line 189
	{
#line 189
	  struct opthelp *opt = opthelp + idxbuf[i];
#line 189
	  size_t len = 5 + strlen (opt->arg)
#line 189
	                 + (opt->is_optional ? 2 : 1);
#line 189
      
#line 189
	  if (n + len > RMARGIN) FLUSH;
#line 189
	  buf[n++] = ' ';
#line 189
	  buf[n++] = '[';
#line 189
	  buf[n++] = '-';
#line 189
	  buf[n++] = opt->opt[1];
#line 189
	  if (opt->is_optional)
#line 189
	    {
#line 189
	      buf[n++] = '[';
#line 189
	      strcpy (&buf[n], opt->arg);
#line 189
	      n += strlen (opt->arg);
#line 189
	      buf[n++] = ']';
#line 189
	    }
#line 189
	  else
#line 189
	    {
#line 189
	      buf[n++] = ' ';
#line 189
	      strcpy (&buf[n], opt->arg);
#line 189
	      n += strlen (opt->arg);
#line 189
	    }
#line 189
	  buf[n++] = ']';
#line 189
	}
#line 189
    }
#line 189
  
#line 189
#ifdef HAVE_GETOPT_LONG
#line 189
  /* Print a list of long options */
#line 189
  for (i = nidx = 0; i < NOPTHELP; i++)
#line 189
    {
#line 189
      if (opthelp[i].opt && opthelp[i].descr
#line 189
	  &&  (opthelp[i].opt[1] == '-' || opthelp[i].opt[2] == ','))
#line 189
	idxbuf[nidx++] = i;
#line 189
    }
#line 189

#line 189
  if (nidx)
#line 189
    {
#line 189
      qsort (idxbuf, nidx, sizeof (idxbuf[0]), cmpidx_long);
#line 189
	
#line 189
      for (i = 0; i < nidx; i++)
#line 189
	{
#line 189
	  struct opthelp *opt = opthelp + idxbuf[i];
#line 189
	  size_t len;
#line 189
	  const char *longopt;
#line 189
	  
#line 189
	  if (opt->opt[1] == '-')
#line 189
	    longopt = opt->opt;
#line 189
	  else if (opt->opt[2] == ',')
#line 189
	    longopt = opt->opt + 4;
#line 189
	  else
#line 189
	    continue;
#line 189

#line 189
	  len = 3 + strlen (longopt)
#line 189
	          + (opt->arg ? 1 + strlen (opt->arg)
#line 189
		  + (opt->is_optional ? 2 : 0) : 0);
#line 189
	  if (n + len > RMARGIN) FLUSH;
#line 189
	  buf[n++] = ' ';
#line 189
	  buf[n++] = '[';
#line 189
	  strcpy (&buf[n], longopt);
#line 189
	  n += strlen (longopt);
#line 189
	  if (opt->arg)
#line 189
	    {
#line 189
	      buf[n++] = '=';
#line 189
	      if (opt->is_optional)
#line 189
		{
#line 189
		  buf[n++] = '[';
#line 189
		  strcpy (&buf[n], opt->arg);
#line 189
		  n += strlen (opt->arg);
#line 189
		  buf[n++] = ']';
#line 189
		}
#line 189
	      else
#line 189
		{
#line 189
		  strcpy (&buf[n], opt->arg);
#line 189
		  n += strlen (opt->arg);
#line 189
		}
#line 189
	    }
#line 189
	  buf[n++] = ']';
#line 189
	}
#line 189
    }
#line 189
#endif
#line 189
  FLUSH;
#line 189
  free (idxbuf);
#line 189
}
#line 189

#line 189
const char version_etc_copyright[] =
#line 189
  /* Do *not* mark this string for translation.  First %s is a copyright
     symbol suitable for this locale, and second %s are the copyright
     years.  */
#line 189
  "Copyright %s %s %s";
#line 189

#line 189
void
#line 189
print_version_only(const char *program_version, FILE *stream)
#line 189
{
#line 189
  fprintf (stream, "%s\n", program_version);
#line 189
  /* TRANSLATORS: Translate "(C)" to the copyright symbol
     (C-in-a-circle), if this symbol is available in the user's
     locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 189
  fprintf (stream, version_etc_copyright, _("(C)"),
#line 189
	   "2011,2012",
#line 189
	   "Sergey Poznyakoff");
#line 189
  fputc ('\n', stream);
#line 189
}
#line 189

#line 189

#line 189

#line 189
void (*print_version_hook)(FILE *stream);
#line 189

#line 189
void
#line 189
print_version(const char *program_version, FILE *stream)
#line 189
{
#line 189
  
#line 189
  print_version_only(program_version, stream);
#line 189

#line 189
  fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 189
	 stream);
#line 189
  if (print_version_hook)
#line 189
    print_version_hook (stream);
#line 189
		
#line 189
}
#line 189

#line 370 "cmdline.opt"

#line 370


void
cfpeek_version_hook(FILE *stream)
{
	fprintf(stream, "compiled with:\n");
	fprintf(stream, "  Grecs %s\n", GRECS_GIT_ID);
#ifdef GUILE_VERSION
	fprintf(stream, "  Guile %s\n", GUILE_VERSION);
#endif
}


void
parse_options(int argc, char *argv[])
{
	program_name = strrchr(argv[0], '/');
	if (program_name)
		program_name++;
	else
		program_name = argv[0];
	print_help_hook = flags_help;
	print_version_hook = cfpeek_version_hook;
        
#line 393
 {
#line 393
  int c;
#line 393

#line 393
#ifdef HAVE_GETOPT_LONG
#line 393
  while ((c = getopt_long(argc, argv, "H:qp:LrSm:s:l:f:e:i:I:D:P:NxXhV",
#line 393
			  long_options, NULL)) != EOF)
#line 393
#else
#line 393
  while ((c = getopt(argc, argv, "H:qp:LrSm:s:l:f:e:i:I:D:P:NxXhV")) != EOF)
#line 393
#endif
#line 393
    {
#line 393
      switch (c)
#line 393
	{
#line 393
	default:
#line 393
	   exit(EX_USAGE);	   exit(EX_USAGE);
#line 393
	#line 200 "cmdline.opt"
	 case 'H':
#line 200
	  {
#line 200

        int i;
        struct wordsplit ws;
	ws.ws_delim = ",";
	if (wordsplit(optarg, &ws,
		      WRDSF_DELIM|WRDSF_SQUEEZE_DELIMS|
		      WRDSF_NOVAR|WRDSF_NOCMD|WRDSF_SHOWERR))
		exit(EX_SOFTWARE);
	for (i = 0; i < ws.ws_wordc; i++) {
		set_flag(ws.ws_wordv[i]);
	}
	wordsplit_free(&ws);

#line 212
	     break;
#line 212
	  }
#line 216 "cmdline.opt"
	 case 'q':
#line 216
	  {
#line 216

	quiet_option++;

#line 218
	     break;
#line 218
	  }
#line 224 "cmdline.opt"
	 case 'p':
#line 224
	  {
#line 224

	if (strcasecmp(optarg, "GRECS") == 0) {
		grecs_parser_fun = grecs_grecs_parser;
		if (preproc_settings == PREPROC_NOT_SET)
			preproc_settings = PREPROC_DEFAULT;
	} else if (strcasecmp(optarg, "META1") == 0)
		grecs_parser_fun = grecs_meta1_parser;
	else if (strcasecmp(optarg, "BIND") == 0)
		grecs_parser_fun = grecs_bind_parser;
	else if (strcasecmp(optarg, "GIT") == 0)
		grecs_parser_fun = grecs_git_parser;
	else if (strcasecmp(optarg, "PATH") == 0)
		grecs_parser_fun = grecs_path_parser;
	else {
		grecs_error(NULL, 0, "unsupported parser type");
		exit(EX_USAGE);
	}

#line 241
	     break;
#line 241
	  }
#line 245 "cmdline.opt"
	 case 'L':
#line 245
	  {
#line 245

	mode = MODE_LITERAL;

#line 247
	     break;
#line 247
	  }
#line 251 "cmdline.opt"
	 case 'r':
#line 251
	  {
#line 251

	reduce_option = 1;

#line 253
	     break;
#line 253
	  }
#line 257 "cmdline.opt"
	 case 'S':
#line 257
	  {
#line 257

       sort_option = 1;

#line 259
	     break;
#line 259
	  }
#line 263 "cmdline.opt"
	 case 'm':
#line 263
	  {
#line 263

	max_matches = atoi(optarg);

#line 265
	     break;
#line 265
	  }
#line 269 "cmdline.opt"
	 case 's':
#line 269
	  {
#line 269

        struct wordsplit ws;

	ws.ws_delim = "=";
	if (wordsplit(optarg, &ws, WRDSF_NOVAR | WRDSF_NOCMD |
                                   WRDSF_QUOTE | WRDSF_CESCAPES	|
				   WRDSF_DELIM)) {
	     grecs_error(NULL, 0, "cannot split string: %s",
	                 wordsplit_strerror(&ws));
	     exit(EX_SOFTWARE);
	}
        if (ws.ws_wordc != 2) {
                grecs_error(NULL, 0, "set: invalid syntax");
		exit(EX_USAGE);
	}
	do {
#line 284
   struct grecs_node *node = grecs_node_from_path(ws.ws_wordv[0], ws.ws_wordv[1]);
#line 284
   if (!cmdline_tree)
#line 284
	cmdline_tree = node;
#line 284
   else
#line 284
	grecs_node_bind(cmdline_tree, node, 0);
#line 284
} while(0)
#line 284
;
        wordsplit_free(&ws);

#line 286
	     break;
#line 286
	  }
#line 292 "cmdline.opt"
	 case 'l':
#line 292
	  {
#line 292

	script_select(optarg);

#line 294
	     break;
#line 294
	  }
#line 298 "cmdline.opt"
	 case 'f':
#line 298
	  {
#line 298

	script_file = optarg;

#line 300
	     break;
#line 300
	  }
#line 304 "cmdline.opt"
	 case 'e':
#line 304
	  {
#line 304

	script_expr = optarg;

#line 306
	     break;
#line 306
	  }
#line 310 "cmdline.opt"
	 case 'i':
#line 310
	  {
#line 310

	script_init_expr = optarg;

#line 312
	     break;
#line 312
	  }
#line 318 "cmdline.opt"
	 case 'I':
#line 318
	  {
#line 318

        if (preproc_settings == PREPROC_NOT_SET)
		preproc_settings = PREPROC_DEFAULT;
	grecs_preproc_add_include_dir(optarg);

#line 322
	     break;
#line 322
	  }
#line 326 "cmdline.opt"
	 case 'D':
#line 326
	  {
#line 326

        char *p;

        if (preproc_settings == PREPROC_NOT_SET)
		preproc_settings = PREPROC_DEFAULT;
        if (!pp_cmd_acc)
		pp_cmd_acc = grecs_txtacc_create();
        grecs_txtacc_grow(pp_cmd_acc, " \"-D", 4);
        for (p = optarg; *p; p++) {
		if (*p == '\\' || *p == '"')
			grecs_txtacc_grow_char(pp_cmd_acc, '\\');
		grecs_txtacc_grow_char(pp_cmd_acc, *p);
	}
	grecs_txtacc_grow_char(pp_cmd_acc, '"');			

#line 340
	     break;
#line 340
	  }
#line 344 "cmdline.opt"
	 case 'P':
#line 344
	  {
#line 344

	grecs_preprocessor = optarg;
        preproc_settings = PREPROC_SET;

#line 347
	     break;
#line 347
	  }
#line 351 "cmdline.opt"
	 case 'N':
#line 351
	  {
#line 351

	grecs_preprocessor = NULL;
        preproc_settings = PREPROC_SET;

#line 354
	     break;
#line 354
	  }
#line 360 "cmdline.opt"
	 case 'x':
#line 360
	  {
#line 360

	grecs_gram_trace(1);

#line 362
	     break;
#line 362
	  }
#line 366 "cmdline.opt"
	 case 'X':
#line 366
	  {
#line 366

	grecs_lex_trace(1);

#line 368
	     break;
#line 368
	  }
#line 370 "cmdline.opt"
	 case 'h':
#line 370
	  {
#line 370

#line 370
		print_help ();
#line 370
		exit (0);
#line 370
	 
#line 370
	     break;
#line 370
	  }
#line 370 "cmdline.opt"
	 case OPTION_USAGE:
#line 370
	  {
#line 370

#line 370
		print_usage ();
#line 370
		exit (0);
#line 370
	 
#line 370
	     break;
#line 370
	  }
#line 370 "cmdline.opt"
	 case 'V':
#line 370
	  {
#line 370

#line 370
		/* Give version */
#line 370
		print_version(program_version, stdout);
#line 370
		exit (0);
#line 370
	 
#line 370
	     break;
#line 370
	  }

#line 393 "cmdline.opt"
	}
#line 393
    }
#line 393
  file_index = optind;
#line 393
  if (cmdline_tree)
#line 393
    {
#line 393
      struct grecs_node *rn = grecs_node_create(grecs_node_root, NULL);
#line 393
      rn->down = cmdline_tree;
#line 393
      cmdline_tree = rn;
#line 393
    }
#line 393
 }
#line 393

	if (!(flags_on & _GRECS_NODE_MASK_OUTPUT)) 
		flags_on |= GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE;
	flags = flags_on & ~flags_off;
	if (!(flags & (GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE))) {
		grecs_warning(NULL, 0, "assuming --format=path,value");
		flags |= GRECS_NODE_FLAG_PATH|GRECS_NODE_FLAG_VALUE;
	}
	if (preproc_settings == PREPROC_DEFAULT)
		grecs_preprocessor = DEFAULT_PREPROCESSOR;
	if (pp_cmd_acc && grecs_preprocessor) {
		char *args, *cmd;

		grecs_txtacc_grow_char(pp_cmd_acc, 0);
		args = grecs_txtacc_finish(pp_cmd_acc, 0);
		cmd = grecs_malloc(strlen(grecs_preprocessor) +
				   strlen(args) + 1);
		strcpy(cmd, grecs_preprocessor);
		strcat(cmd, args);
		grecs_preprocessor = cmd;
	}
	grecs_txtacc_free(pp_cmd_acc);

	script_init();
}
